#ifndef MISSING_MATH_H
#define MISSING_MATH_H

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/param.h>

#if __FreeBSD_version < 704102 || \
(__FreeBSD_version >= 800000 && __FreeBSD_version < 802502) || \
(__FreeBSD_version >= 900000 && __FreeBSD_version < 900027)
double			log2(double);
float			log2f(float);
#endif
#if __FreeBSD_version < 800007
#if 0
double			nan(const char *);
float			nanf(const char *);
long double		nanl(const char *);
#endif
long double		logbl(long double);
#endif
#if __FreeBSD_version < 800012
long long int		llrintl(long double);
long int		lrintl(long double);
long double		nearbyintl(long double);
long double		rintl(long double);
long double		exp2l(long double);
#endif
#if __FreeBSD_version < 800022
long double		sinl(long double);
long double		cosl(long double);
long double		tanl(long double);
float			tgammaf(float);
#endif
#if __FreeBSD_version < 800025
long double		sqrtl(long double);
#endif
#if __FreeBSD_version < 800030
long double		hypotl(long double, long double);
long double		remainderl(long double, long double);
long double		remquol(long double, long double, int);
#endif
#if __FreeBSD_version < 800040
long double		fmodl(long double, long double);
#endif
#if __FreeBSD_version < 800042
long double		acosl(long double);
long double		asinl(long double);
long double		atan2l(long double, long double);
long double		atanl(long double);
#endif
#if __FreeBSD_version < 900035
long double		cbrtl(long double);
#endif
#if __FreeBSD_version < 1000016
long double		expl(long double);
#endif
long double		acoshl(long double);
long double		asinhl(long double);
long double		atanhl(long double);
long double		coshl(long double);
long double		erfcl(long double);
long double		erfl(long double);
long double		expm1l(long double);
long double		lgammal(long double);
long double		log10l(long double);
long double		log1pl(long double);
long double		log2l(long double);
long double		logl(long double);
long double		powl(long double, long double);
long double		sinhl(long double);
long double		tanhl(long double);
long double		tgammal(long double);

#ifdef __cplusplus
}
#endif
#endif
